﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using SingularSys.Jep;

namespace HalfTest
{
    class HalfTest
    {
        static void Main(string[] args)
        {
            JepInstance parser = new JepInstance();        // Create a new parser
		    String expr = "10 + half(4)";
		    Object value;
    		
		    Console.Out.WriteLine("Starting CustFunc...");
		    // Add the custom function
            parser.FunTab.AddFunction("half", new Half());
    		
		    try {
			    parser.Parse(expr);                 // Parse the expression
		    } catch (ParseException e) {
			    Console.Out.WriteLine("Error while parsing");
			    Console.Out.WriteLine(e.Message);
			    return;
		    }
    		
		    try {
			    value = parser.Evaluate();                    // Get the value
		    } catch (EvaluationException e) {
			    Console.Out.WriteLine("Error during evaluation");
			    Console.Out.WriteLine(e.Message);
			    return;
		    }
    		
		    Console.Out.WriteLine(expr + " = " + value); // Print value

            Console.ReadKey(true);
        }

    }
}
