﻿using SingularSys.Jep.Functions;
using SingularSys.Jep.Standard;

using System.Collections;
using System.Collections.Generic;
using NUnit.Framework;
using SingularSys.Jep.Types;

namespace SingularSys.Jep.JepTests.Functions
{


    /// <summary>
    ///This is a test class for AddTest and is intended
    ///to contain all AddTest Unit Tests
    ///</summary>
    [TestFixture]
    public class PfmcAddTest
    {

        // FROM VS 2008 PPROFESSIONAL -- START
        //private TestContext testContextInstance;

        ///// <summary>
        /////Gets or sets the test context which provides
        /////information about and functionality for the current test run.
        /////</summary>
        //public TestContext TestContext
        //{
        //    get
        //    {
        //        return testContextInstance;
        //    }
        //    set
        //    {
        //        testContextInstance = value;
        //    }
        //}

        //#region Additional test attributes
        //// 
        ////You can use the following additional attributes as you write your tests:
        ////
        ////Use ClassInitialize to run code before running the first test in the class
        ////[ClassInitialize()]
        ////public static void MyClassInitialize(TestContext testContext)
        ////{
        ////}
        ////
        ////Use ClassCleanup to run code after all tests in a class have run
        ////[ClassCleanup()]
        ////public static void MyClassCleanup()
        ////{
        ////}
        ////
        ////Use TestInitialize to run code before running each test
        ////[TestInitialize()]
        ////public void MyTestInitialize()
        ////{
        ////}
        ////
        ////Use TestCleanup to run code after each test has run
        ////[TestCleanup()]
        ////public void MyTestCleanup()
        ////{
        ////}
        ////
        //#endregion
        // FROM VS 2008 PPROFESSIONAL -- END


        /// <summary>
        ///A test for Run
        ///</summary>
        [Test]
        public void RunTest()
        {
            Add target = new Add(); // TODO: Initialize to an appropriate value
            Stack<object> stack = new Stack<object>(); // TODO: Initialize to an appropriate value

            object o = "ab";

            stack.Push(o);
            stack.Push(o);
            target.SetCurNumberOfParameters(2);
            target.Run(stack);
            Assert.AreEqual("abab", (string)stack.Pop());
            // Assert.Inconclusive("A method that does not return a value cannot be verified.");
        }

        /// <summary>
        ///A test for evaluate(double, double)
        ///</summary>
        [Test]
        public void EvaluateTest()
        {
            Add target = new Add();
            double l = 1.0;
            double r = 2.0;
            double expected = 3.0;
            double actual;
            actual = target.Evaluate(l, r);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Add(JepDouble, JepDouble)
        ///</summary>
        [Test]
        public void AddTestDoubles()
        {
            Add target = new Add();
            JepDouble d1 = new JepDouble(0.0);
            JepDouble d2 = new JepDouble(0.0);
            JepDouble expected = new JepDouble(0.0);
            JepDouble actual;
            actual = target.AddOp(d1, d2);
            Assert.AreEqual(expected.Value, actual.Value);
        }

        /// <summary>
        ///A test for Add(object, object)
        ///</summary>
        [Test]
        public void AddTestObjects()
        {
            Add target = new Add();
            object param1 = "ab";
            object param2 = "cd";
            object expected = "abcd";
            object actual;
            actual = target.AddOp(param1, param2);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Add(complex, double)
        ///</summary>
        [Test]
        public void AddTestComplexDouble()
        {
            Add target = new Add();
            Complex c = new Complex(1.0, 1);
            JepDouble d = new JepDouble(2.0);
            Complex expected = new Complex(3.0, 1);
            Complex actual;
            actual = (Complex)target.AddOp(c, d);
            Assert.IsTrue(expected.IsEqual(actual));
        }

        /// <summary>
        ///A test for Add(ArrayList, ArrayList)
        ///</summary>
        [Test]
        public void AddTestArrayLists()
        {
            Add target = new Add();
            ArrayList v1 = new ArrayList(2);
            ArrayList v2 = new ArrayList(2);
            ArrayList expected = new ArrayList(2);

            v1.Insert(0, "a");
            v2.Insert(0, "b");
            expected.Insert(0, "ab");

            v1.Insert(1, "ab");
            v2.Insert(1, "cd");
            expected.Insert(1, "abcd");

            ArrayList actual;
            actual = target.AddOp(v1, v2);
            Assert.AreEqual(expected.Count, actual.Count);
            for (int i = 0; i < expected.Count; i++)
            {
                Assert.AreEqual(expected[i], actual[i]);
            }
        }

        /// <summary>
        ///A test for Add(Complex, Complex)
        ///</summary>
        [Test]
        public void AddTestComplex()
        {
            Add target = new Add();
            Complex c1 = new Complex(1.0, 1);
            Complex c2 = new Complex(2.0, 2);
            Complex expected = new Complex(3.0, 3);
            Complex actual;
            actual = target.AddOp(c1, c2);
            Assert.IsTrue(expected.IsEqual(actual));
        }

        /// <summary>
        ///A test for Add Constructor
        ///</summary>
        [Test]
        public void AddConstructorTest()
        {
            Add target = new Add();
            Assert.IsTrue(target != null);
        }
    }
}
